org.apache.lucene.geo3d

## Class GeoConvexPolygon

- java.lang.Object
- - org.apache.lucene.geo3d.BasePlanetObject
  - - org.apache.lucene.geo3d.GeoBaseShape
    - - org.apache.lucene.geo3d.GeoBaseMembershipShape
      - - org.apache.lucene.geo3d.GeoBasePolygon
        - - org.apache.lucene.geo3d.GeoConvexPolygon

- All Implemented Interfaces:
    GeoMembershipShape, GeoOutsideDistance, GeoPolygon, GeoShape, Membership

      public class GeoConvexPolygon
      extends GeoBasePolygon

  GeoConvexPolygon objects are generic building blocks of more complex structures. The only restrictions on these objects are: (1) they must be convex; (2) they must have a maximum extent no larger than PI. Violating either one of these limits will cause the logic to fail.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected GeoPoint[]` | `edgePoints` A point which is on the boundary of the polygon
    `protected SidedPlane[]` | `edges` A list of edges
    `protected double` | `fullDistance` Tracking the maximum distance we go at any one time, so to be sure it's legal
    `protected boolean` | `isDone` Set to true when the polygon is complete
    `protected BitSet` | `isInternalEdges` A bitset describing, for each edge, whether it is internal or not
    `protected GeoPoint[][]` | `notableEdgePoints` The set of notable points for each edge
    `protected List<GeoPoint>` | `points` The list of polygon points

    - ### Fields inherited from class org.apache.lucene.geo3d.BasePlanetObject

      `planetModel`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GeoConvexPolygon(PlanetModel planetModel, double startLatitude, double startLongitude)` Create a convex polygon, with a starting latitude and longitude.
    `GeoConvexPolygon(PlanetModel planetModel, List<GeoPoint> pointList)` Create a convex polygon from a list of points.
    `GeoConvexPolygon(PlanetModel planetModel, List<GeoPoint> pointList, BitSet internalEdgeFlags, boolean returnEdgeInternal)` Create a convex polygon from a list of points, keeping track of which boundaries are internal.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addPoint(double latitude, double longitude, boolean isInternalEdge)` Add a point to the polygon.
    `protected void` | `createCenterPoint()` Compute a reasonable center point.
    `void` | `done(boolean isInternalReturnEdge)` Finish the polygon, by connecting the last added point with the starting point.
    `boolean` | `equals(Object o)`
    `void` | `getBounds(Bounds bounds)` Compute bounds for the shape.
    `GeoPoint[]` | `getEdgePoints()` Return a sample point that is on the outside edge/boundary of the shape.
    `int` | `hashCode()`
    `boolean` | `intersects(Plane p, GeoPoint[] notablePoints, Membership... bounds)` Assess whether a plane, within the provided bounds, intersects with the shape.
    `boolean` | `isWithin(double x, double y, double z)` Check if a point is within this shape.
    `protected int` | `legalIndex(int index)` Compute a legal point index from a possibly illegal one, that may have wrapped.
    `protected double` | `outsideDistance(DistanceStyle distanceStyle, double x, double y, double z)` Called by a `computeOutsideDistance` method if X/Y/Z is not within this shape.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.lucene.geo3d.GeoBaseMembershipShape

      `computeOutsideDistance, computeOutsideDistance, isWithin`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.lucene.geo3d.GeoOutsideDistance

      `computeOutsideDistance, computeOutsideDistance`

    - ### Methods inherited from interface org.apache.lucene.geo3d.Membership

      `isWithin`

- - ### Field Detail

    - #### points

          protected final List<GeoPoint> points

      The list of polygon points

    - #### isInternalEdges

          protected final BitSet isInternalEdges

      A bitset describing, for each edge, whether it is internal or not

    - #### edges

          protected SidedPlane[] edges

      A list of edges

    - #### notableEdgePoints

          protected GeoPoint[][] notableEdgePoints

      The set of notable points for each edge

    - #### edgePoints

          protected GeoPoint[] edgePoints

      A point which is on the boundary of the polygon

    - #### fullDistance

          protected double fullDistance

      Tracking the maximum distance we go at any one time, so to be sure it's legal

    - #### isDone

          protected boolean isDone

      Set to true when the polygon is complete

  - ### Constructor Detail

    - #### GeoConvexPolygon

          public GeoConvexPolygon(PlanetModel planetModel,
                          List<GeoPoint> pointList)

      Create a convex polygon from a list of points. The first point must be on the external edge.
      Parameters:
        `planetModel` - is the planet model.
        `pointList` - is the list of points to create the polygon from.

    - #### GeoConvexPolygon

          public GeoConvexPolygon(PlanetModel planetModel,
                          List<GeoPoint> pointList,
                          BitSet internalEdgeFlags,
                          boolean returnEdgeInternal)

      Create a convex polygon from a list of points, keeping track of which boundaries are internal. This is used when creating a polygon as a building block for another shape.
      Parameters:
        `planetModel` - is the planet model.
        `pointList` - is the set of points to create the polygon from.
        `internalEdgeFlags` - is a bitset describing whether each edge is internal or not.
        `returnEdgeInternal` - is true when the final return edge is an internal one.

    - #### GeoConvexPolygon

          public GeoConvexPolygon(PlanetModel planetModel,
                          double startLatitude,
                          double startLongitude)

      Create a convex polygon, with a starting latitude and longitude. Accepts only values in the following ranges: lat: `-PI/2 -> PI/2`, lon: `-PI -> PI`
      Parameters:
        `planetModel` - is the planet model.
        `startLatitude` - is the latitude of the first point.
        `startLongitude` - is the longitude of the first point.

  - ### Method Detail

    - #### addPoint

          public void addPoint(double latitude,
                      double longitude,
                      boolean isInternalEdge)

      Add a point to the polygon. Accepts only values in the following ranges: lat: `-PI/2 -> PI/2`, lon: `-PI -> PI`
      Parameters:
        `latitude` - is the latitude of the next point.
        `longitude` - is the longitude of the next point.
        `isInternalEdge` - is true if the edge just added with this point should be considered "internal", and not intersected as part of the intersects() operation.

    - #### done

          public void done(boolean isInternalReturnEdge)

      Finish the polygon, by connecting the last added point with the starting point.
      Parameters:
        `isInternalReturnEdge` - is true if the return edge (back to start) is an internal one.

    - #### createCenterPoint

          protected void createCenterPoint()

      Compute a reasonable center point.

    - #### legalIndex

          protected int legalIndex(int index)

      Compute a legal point index from a possibly illegal one, that may have wrapped.
      Parameters:
        `index` - is the index.
      Returns:
        the normalized index.

    - #### isWithin

          public boolean isWithin(double x,
                         double y,
                         double z)

      Description copied from interface: `Membership`
      Check if a point is within this shape.
      Parameters:
        `x` - is x coordinate of point to check.
        `y` - is y coordinate of point to check.
        `z` - is z coordinate of point to check.
      Returns:
        true if the point is within this shape

    - #### getEdgePoints

          public GeoPoint[] getEdgePoints()

      Description copied from interface: `GeoShape`
      Return a sample point that is on the outside edge/boundary of the shape.
      Returns:
        samples of all edge points from distinct edge sections. Typically one point is returned, but zero or two are also possible.

    - #### intersects

          public boolean intersects(Plane p,
                           GeoPoint[] notablePoints,
                           Membership... bounds)

      Description copied from interface: `GeoShape`
      Assess whether a plane, within the provided bounds, intersects with the shape. Note well that this method is allowed to return "true" if there are internal edges of a composite shape which intersect the plane. Doing this can cause getRelationship() for most GeoBBox shapes to return OVERLAPS rather than the more correct CONTAINS, but that cannot be helped for some complex shapes that are built out of overlapping parts.
      Parameters:
        `p` - is the plane to assess for intersection with the shape's edges or bounding curves.
        `notablePoints` - represents the intersections of the plane with the supplied bounds. These are used to disambiguate when two planes are identical and it needs to be determined whether any points exist that fulfill all the bounds.
        `bounds` - are a set of bounds that define an area that an intersection must be within in order to qualify (provided by a GeoArea).
      Returns:
        true if there's such an intersection, false if not.

    - #### getBounds

          public void getBounds(Bounds bounds)

      Description copied from interface: `GeoShape`
      Compute bounds for the shape.
      Specified by:
        `getBounds` in interface `GeoShape`
      Overrides:
        `getBounds` in class `GeoBaseShape`
      Parameters:
        `bounds` - is the input bounds object. The input object will be modified.

    - #### outsideDistance

          protected double outsideDistance(DistanceStyle distanceStyle,
                               double x,
                               double y,
                               double z)

      Description copied from class: `GeoBaseMembershipShape`
      Called by a `computeOutsideDistance` method if X/Y/Z is not within this shape.
      Specified by:
        `outsideDistance` in class `GeoBaseMembershipShape`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `BasePlanetObject`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `BasePlanetObject`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.